
package com.dodo.sfnotes;

import android.app.Activity;
import android.content.pm.ActivityInfo;
import android.app.NativeActivity;
import android.os.Environment;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Bundle;
import android.provider.MediaStore;
import android.util.DisplayMetrics;
import android.content.ActivityNotFoundException;
 
public class MyActivity extends NativeActivity 
{
 
static { System.loadLibrary("sfnotes"); }

public static native void haveresult(int rcode);

private String gdd_s1;
private String cif_s1;

private static int RESULT_CHOOSE_IMAGE = 1;

public void get_download_dir()
{
   gdd_s1= Environment.getExternalStoragePublicDirectory
                (Environment.DIRECTORY_DOWNLOADS).getAbsolutePath();
}

public void choose_image_file()
{
    Intent i= new Intent(Intent.ACTION_PICK,
              android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
    startActivityForResult(i, RESULT_CHOOSE_IMAGE);
}
  
@Override
protected void onActivityResult
      (int requestCode, int resultCode, Intent data) 
{
  super.onActivityResult(requestCode, resultCode, data);

  if (requestCode==RESULT_CHOOSE_IMAGE)
  {
    if (resultCode!=RESULT_OK || data==null)
    {
      cif_s1= null;
      haveresult(requestCode);
      return ;
    }
    Uri selectedImage = data.getData();
    String[] filePathColumn = { MediaStore.Images.Media.DATA };

    Cursor cursor = getContentResolver().query(selectedImage,
                       filePathColumn, null, null, null);
    cursor.moveToFirst();

    int columnIndex = cursor.getColumnIndex(filePathColumn[0]);
    String picturePath = cursor.getString(columnIndex);
    cursor.close();
    cif_s1= picturePath;
    haveresult(requestCode);
  }
}

@Override
protected void onCreate(Bundle savedInstanceState) {
   super.onCreate(savedInstanceState);
   // setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
   setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
}

public int getStatusBarHeight() 
{
  int result= 0;
  int resourceId= getResources().getIdentifier
                          ("status_bar_height", "dimen", "android");
  if (resourceId > 0)
  {
      result= getResources().getDimensionPixelSize(resourceId);
  }
  return result;
}

public int getDisplayDPI()
{
  DisplayMetrics dm = new DisplayMetrics();
  getWindowManager().getDefaultDisplay().getMetrics(dm);

  float xDpi = dm.xdpi;
  float yDpi = dm.ydpi;

  if (xDpi>yDpi) return (int) xDpi; else return (int) yDpi;
}

public void rateApp()
{
  Uri uri = Uri.parse("market://details?id=" + getPackageName());
  Intent goToMarket = new Intent(Intent.ACTION_VIEW, uri);
  // To count with Play market backstack, After pressing back button, 
  // to taken back to our application, we need to add following flags to intent. 
  goToMarket.addFlags(Intent.FLAG_ACTIVITY_NO_HISTORY |
                    // Intent.FLAG_ACTIVITY_NEW_DOCUMENT |
                    Intent.FLAG_ACTIVITY_MULTIPLE_TASK);
  try
  {
    startActivity(goToMarket);
  }
  catch (ActivityNotFoundException e)
  {
      startActivity(new Intent(Intent.ACTION_VIEW,
          Uri.parse("http://play.google.com/store/apps/details?id=" 
                      + getPackageName())));
  }
}


}

