#include <math.h>

/***********************************************************************
 *                                                                     *
 *                            X BASED LINES                            *
 *                                                                     *
 ***********************************************************************/

static void aapixel(int x,int y, int rem, int step,int color)
{
  int v;
  if (rem<0) return ;
#if 0
  if (rem>=2*step) v= 0xff;
  else
  {
    if (rem>=step) v=  (step-(2*step-rem)*2/10)*255/step;
              else v= rem*255/step;
  }
#else
  if (rem>=step) v= 0xff;
            else v= rem*255/step;
  
#endif
  pixel(x,y, v, color);
}

static void x_perpendicular
         (int x0,int y0,int dx,int dy,int xstep, int ystep,
          int einit,int w_left, int w_right,int winit,int color)
{
  int x,y,threshold,E_diag,E_square;
  int tk;
  int error;
  int p,q;

  threshold = dx - 2*dy;
  E_diag= -2*dx;
  E_square= 2*dy;
  p=q=0;

  y= y0;
  x= x0;
  error= einit;
  // tk= dx+dy-winit; 
  tk= - winit;

  while(tk<=w_left)
  {
     aapixel(x,y, w_left-tk, 2*dx, color);
     if (error>=threshold)
     {
       x= x + xstep;
       error = error + E_diag;
       tk= tk + 2*dy;
     }
     error = error + E_square;
     y= y + ystep;
     tk= tk + 2*dx;
     q++;
  }

  y= y0;
  x= x0;
  error= -einit;
  // tk= dx+dy+winit;
  tk= winit;

  while(tk<=w_right)
  {
     if (p)
       aapixel(x,y, w_right-tk, 2*dx,color);
     if (error>threshold)
     {
       x= x - xstep;
       error = error + E_diag;
       tk= tk + 2*dy;
     }
     error = error + E_square;
     y= y - ystep;
     tk= tk + 2*dx;
     p++;
  }

   // we need this for very thin lines 
  if (q==0 && p<2) aapixel(x0,y0, 2*dx, 2*dx,color);
}


static void x_varthick_line
   (int x0,int y0,int dx,int dy,int xstep, int ystep,
    double (*left)(void *,int ,int), void *argL,
    double (*right)(void *,int ,int),void *argR, int pxstep,int pystep,
    int color)
{
  int p_error, error, x,y, threshold, E_diag, E_square, length, p;
  int w_left, w_right;
  double D;


  p_error= 0;
  error= 0;
  y= y0;
  x= x0;
  threshold = dx - 2*dy;
  E_diag= -2*dx;
  E_square= 2*dy;
  length = dx+1;
  D= sqrt(dx*dx+dy*dy);

  for(p=1;p<length;p++)
  {
    w_left=  (*left)(argL, p, length)*2*D;
    w_right= (*right)(argR,p, length)*2*D;
    x_perpendicular(x,y, dx, dy, pxstep, pystep,
                                      p_error,w_left,w_right,error,color);
    if (error>=threshold)
    {
      y= y + ystep;
      error = error + E_diag;
      if (p_error>=threshold) 
      {
        x_perpendicular(x,y, dx, dy, pxstep, pystep,
                                    (p_error+E_diag+E_square), 
                                     w_left,w_right,error,color);
        p_error= p_error + E_diag;
      }
      p_error= p_error + E_square;
    }
    error = error + E_square;
    x= x + xstep;
  }
}

/***********************************************************************
 *                                                                     *
 *                            Y BASED LINES                            *
 *                                                                     *
 ***********************************************************************/

static void y_perpendicular
        (int x0,int y0,int dx,int dy,int xstep, int ystep,
         int einit,int w_left, int w_right,int winit, int color)
{
  int x,y,threshold,E_diag,E_square;
  int tk;
  int error;
  int p,q;

  p=q= 0;
  threshold = dy - 2*dx;
  E_diag= -2*dy;
  E_square= 2*dx;

  y= y0;
  x= x0;
  error= -einit;
  // tk= dx+dy+winit; 
  tk= winit;

  while(tk<=w_left)
  {
     aapixel(x,y, w_left-tk, 2*dy, color);
     if (error>threshold)
     {
       y= y + ystep;
       error = error + E_diag;
       tk= tk + 2*dx;
     }
     error = error + E_square;
     x= x + xstep;
     tk= tk + 2*dy;
     q++;
  }


  y= y0;
  x= x0;
  error= einit;
  // tk= dx+dy-winit; 
  tk= -winit;

  while(tk<=w_right)
  {
     if (p)
       aapixel(x,y, w_right-tk, 2*dy, color);
     if (error>=threshold)
     {
       y= y - ystep;
       error = error + E_diag;
       tk= tk + 2*dx;
     }
     error = error + E_square;
     x= x - xstep;
     tk= tk + 2*dy;
     p++;
  }
    // we need this for very thin lines
  if (q==0 && p<2) aapixel(x0,y0, 2*dy, 2*dy, color);
}


static void y_varthick_line
   (int x0,int y0,int dx,int dy,int xstep, int ystep,
    double (*left)(void *,int ,int), void *argL,
    double (*right)(void *,int ,int),void *argR,int pxstep,int pystep,int color)
{
  int p_error, error, x,y, threshold, E_diag, E_square, length, p;
  int w_left, w_right;
  double D;

  p_error= 0;
  error= 0;
  y= y0;
  x= x0;
  threshold = dy - 2*dx;
  E_diag= -2*dy;
  E_square= 2*dx;
  length = dy+1;
  D= sqrt(dx*dx+dy*dy);

  for(p=1;p<length;p++)
  {
    w_left=  (*left)(argL, p, length)*2*D;
    w_right= (*right)(argR,p, length)*2*D;
    y_perpendicular(x,y, dx, dy, pxstep, pystep,
                                      p_error,w_left,w_right,error,color);
    if (error>=threshold)
    {
      x= x + xstep;
      error = error + E_diag;
      if (p_error>=threshold)
      {
        y_perpendicular(x,y, dx, dy, pxstep, pystep,
                                     p_error+E_diag+E_square,
                                     w_left,w_right,error,color);
        p_error= p_error + E_diag;
      }
      p_error= p_error + E_square;
    }
    error = error + E_square;
    y= y + ystep;
  }
}


/***********************************************************************
 *                                                                     *
 *                                ENTRY                                *
 *                                                                     *
 ***********************************************************************/

static void draw_varthick_line
      (int x0,int y0,int x1, int y1,
       double (*left)(void *,int ,int), void *argL,
       double (*right)(void *,int ,int), void *argR, int color)
{
  int dx,dy,xstep,ystep;
  int pxstep, pystep;
  int xch; // whether left and right get switched.

  dx= x1-x0;
  dy= y1-y0;
  xstep= ystep= 1;

  if (dx<0) { dx= -dx; xstep= -1; }
  if (dy<0) { dy= -dy; ystep= -1; }

  if (dx==0) xstep= 0;
  if (dy==0) ystep= 0;


  xch= 0;
  switch(xstep + ystep*4)
  {
    case -1 + -1*4 :  pystep= -1; pxstep= 1; xch= 1; break;   // -5
    case -1 +  0*4 :  pystep= -1; pxstep= 0; xch= 1; break;   // -1
    case -1 +  1*4 :  pystep=  1; pxstep= 1; break;   // 3
    case  0 + -1*4 :  pystep=  0; pxstep= -1; break;  // -4
    case  0 +  0*4 :  pystep=  0; pxstep= 0; break;   // 0
    case  0 +  1*4 :  pystep=  0; pxstep= 1; break;   // 4
    case  1 + -1*4 :  pystep= -1; pxstep= -1; break;  // -3
    case  1 +  0*4 :  pystep= -1; pxstep= 0;  break;  // 1
    case  1 +  1*4 :  pystep=  1; pxstep= -1; xch=1; break;  // 5
  }

  if (xch) { void *K;
    K= argL; argL= argR; argR= K;
    K= left; left= right; right= K; }

  if (dx>dy) x_varthick_line(x0,y0,dx,dy,xstep,ystep,
                             left,argL,right,argR,
                             pxstep,pystep,color);
        else y_varthick_line(x0,y0,dx,dy,xstep,ystep,
                             left,argL,right,argR,
                             pxstep,pystep,color);
}
