
static void apply_stroke(shape_t *S, int x, int y, 
                         int dx, int dy, int color)
{
  int i,ss,L;
  dpoint_t *T;
  ss= (dx+1) + (dy+1)*3;
  T= S->strokes[ss].data;
  L= S->strokes[ss].len;
  for(i=0;i<L;i++)
     pixel(x+T[i].dx, y+T[i].dy, T[i].value, color);
}

static void brush_line(int skipfirst,
                       shape_t *S,int x0, int y0, int x1, int y1,int color)
{
   int dx =  abs(x1-x0), sx = x0<x1 ? 1 : -1;
   int dy = -abs(y1-y0), sy = y0<y1 ? 1 : -1; 
   int err = dx+dy, e2; /* error value e_xy */
   int mx, my;
 
   mx= 0; my= 0;
   if (!skipfirst) apply_stroke(S, x0,y0, mx,my, color);
   for(;;){  /* loop */
      if (x0==x1 && y0==y1) break;
      e2 = 2*err;
      mx= 0; my= 0;
      if (e2 >= dy) { err += dy; x0 += sx; mx= sx; } /* e_xy+e_x > 0 */
      if (e2 <= dx) { err += dx; y0 += sy; my= sy; } /* e_xy+e_y < 0 */
      apply_stroke(S, x0,y0, mx,my, color);
   }
}

