#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "gfx.h"
#include "book.h"
#include "mkabout.h"
#include "enviro.h"
#include "config.h"

static char *licence_text[]=
{
#include "licence.ci"
  NULL
};

#define YPAD 25
#define XPAD 10
#define SPC  3

static int dw, dh;
static unsigned int *dd;
static book_t *book;
static int npages;

static void alloc_page()
{
  int sz;
  sz= sizeof(dd[0])*dw*dh;
  if (!dd)
     dd= malloc(sz);
  memset(dd, 0xff, sz);
  if (npages>=book->npages)
    book_make_page(book,book->npages);
  npages++;
}

static unsigned int invquad(unsigned char d)
{
  unsigned int K;
  K= d ^ 0xff;
  // K= d;
  return (0xff<<24) | (K<<16) | (K<<8) | (K);
}


static void write_page()
{
  uint32_t *tdata, tw,th;
  
  book_update_image(book, book->npages-1, 0, dw, dh, dd, 0);
  if (resize_image_argb(dd, dw, dh, 
                        config.thumb_w, config.thumb_h,
                        &tdata, &tw, &th))
    return ;
  book_update_image(book, book->npages-1, 1, tw, th, tdata, 0);
  free(tdata);
}



void make_about_file(int w, int h)
{
  int i,y;
  unsigned int *data;
  int  line;
  char *ll;
  int tw, th; unsigned char *td;
  int r,c,font;

  if (book_create("about.not", &book)) { book_close(book); return ; }

  line= 0;
  y= YPAD;
  dw= w; dh= h;
  npages= 0;
  alloc_page();

  while((ll=licence_text[line++]))
  {
    font= 1;
    if (ll[0]=='!') { font++; ll++; }
    if (ll[0]=='!') { font++; ll++; }
    if (!ll[0]) ll= " ";
    gfx_text_data(font,ll,&tw,&th,NULL,&td);
    if (y+th+YPAD>dh) { write_page(); alloc_page(); y= YPAD; }
    for(r=0;r<th;r++)
     for(c=0;c<tw;c++)
     {
       if (c+XPAD>=dw) break; 
       dd[ (c+XPAD) + (r+y)*dw] = invquad(td[c+r*tw]);
     }
    free(td);
    y+= th + SPC;
  }
  write_page();
  book_cleanup(book);
  book_close(book);
  book= NULL;
  free(dd);
  dd= NULL;
}
